/* ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
  	DATABASE EXAMPLE   VERSION 1.0  06/15/83 11:18
  
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

#include <stdio.h>
#include <DATABASE.H>

struct {
	BYTE CDF[LCDF];
	BYTE CNO[LCNO];
	BYTE CFN[LCFN];
	BYTE CLN[LCLN];
	BYTE CST[LCST];
	BYTE CTY[LCTY];
	BYTE CSA[LCSA];
	BYTE CZP[LCZP];
	BYTE CSU[LCSU];	
       } datbuf;

FILE *syslst,*syscon;

main ()
{

if (!(syslst = fopen("LST:","w")))
	{ printf("\n\nCould not open the system list device!");
	  exit(1);
	}
if (!(syscon = fopen("CON:","w")))
	{ printf("\n\nCould not open the system console!");
	  exit(1);
	}

/*
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
  	 SET-UP DATABASE FIELD && KEY DESCRIPTORS
  
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

no_fields = MAX_FIELD + 1;

strcpy(db[0].fld_nam,"Customer Number");
db[0].fld_len = LCNO;
strcpy(db[1].fld_nam,"First Name");
db[1].fld_len = LCFN;
strcpy(db[2].fld_nam,"Last Name");
db[2].fld_len = LCLN;
strcpy(db[3].fld_nam,"Street Address");
db[3].fld_len = LCST;
strcpy(db[4].fld_nam,"City");
db[4].fld_len = LCTY;
strcpy(db[5].fld_nam,"State");
db[5].fld_len = LCSA;
strcpy(db[6].fld_nam,"Zipcode");
db[6].fld_len = LCZP;
strcpy(db[7].fld_nam,"Customer Status");
db[7].fld_len = LCSU;


ky[0].key_len = 10;
ky[0].key_typ = 0;
ky[0].key_map = 2 ;	/*   KEY 0 = LAST NAME		*/
ky[1].key_len = 11;
ky[1].key_typ = 0;
ky[1].key_map = 6 ;	/*   KEY 1 = ZIPCODE		*/
ky[2].key_len = 4 ;
ky[2].key_typ = 0;
ky[2].key_map = 0 ;	/*   KEY 2 = CUST NUMBER	*/

uniq_key = 2 ;	/*  USED IN TEST OF UNIQUENESS	*/

for (key = 0; key <= MAX_KEY; key++)
	{ if (key == uniq_key)
		ky[key].key_dup = NO;
	  else
		ky[key].key_dup = YES;

	  strcpy(ky[key].key_name,db[ky[key].key_map].fld_nam);
	}

idx_name[0].len = strlen(strcpy(idx_name[0].str,"NAME.IDX"));
idx_name[1].len = strlen(strcpy(idx_name[1].str,"ZIPC.IDX"));
idx_name[2].len = strlen(strcpy(idx_name[2].str,"NUMB.IDX"));

/*  
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		INITIALIZE INDEX FILES
  
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

idx_key.len = strlen(strcpy(idx_key.str,SET_LENGTH));

/*
	SET terminal TO -1 FOR AUTOMATIC ASSIGNMENT BY AM-86
 */

trap_errors = YES;
timout = 2;  		/* APPROXIMATELY 2 SECONDS */
terminal = INTUSR(-1,trap_errors,timout);
if (ERRCOD())
	error_type(0,14);

no_buffers = 5;
no_node_sectors = 4;
no_keys = MAX_KEY + 1;

if (SETUP(no_buffers,no_keys,no_node_sectors,1))
	{ printf("\nIllegal SETUP Parameters");
	  exit(1);
	}

for (key = 0; key <= MAX_KEY; key++)
	{ ky[key].key_num = OPNIDX(-1,&idx_name[key], \
		ky[key].key_len,ky[key].key_typ,ky[key].key_dup);
	  if (ERRCOD())
		error_type(key,1);
	}

/*
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		INITIALIZE DATA FILE
  
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

record_length = 100;
filname.len = strlen(strcpy(filname.str,"CUSTOMER.DAT"));
file_no = OPNDAT(-1,S_FILE,&filname,record_length);
if (ERRCOD())
	error_type(0,10);
if (LOKCOD())
	loktyp(1);

/*
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		BEGIN DATABASE OPERATION
  
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

	while (FOREVER)
		data_base();
}

VOID data_base()
    {
    WORD lock_code,ndrn,drn,choice,action,contnu;
    WORD save_key,ldrn,no_listed,stayput;
    BYTE route;
    struct am86strg l_value,u_value,conv_target,target;


    clrscr();
    switch (main_menu())
	{
/*
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		ENTER NEW CUSTOMERS
   
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

case 1:
	action = SAVE;
	while (action == SAVE)
		{
		if ((action = entdat(NEWDAT,0)) == SAVE)
			{ ndrn = update(0);
			  lock_code = FRELOK(file_no,X_LOCK,ndrn);
			}
		else
			lock_code = 0;

		if (lock_code)
			loktyp(8);
		}
	return;

/*
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		SCAN/UPDATE/DELETE CUSTOMERS
  
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

case 2:
	key = search_key();
	printf("\n\nEnter target value for %s,",ky[key].key_name);
	printf("\n    or enter a period (.) to see main menu>>");
	scanf("%11s",target.str);
	target.len = strlen(target.str);
	if (strcmp(target.str,".") == 0) return;

	key_format(key,&target,&conv_target);
	stayput = YES;
	while (stayput)
		{
		drn = SERKEY(ky[key].key_num,file_no,S_LOCK, \
			&conv_target,&idx_key);
		if (ERRCOD())
			error_type(key,2);
		if (LOKCOD())
			stayput = check_lock(key,drn);
		else
			stayput =NO;
		}
	
	old_action = CONT;
	contnu = YES;
	while (contnu && drn)
		{
		ldrn = drn;
		read_cust(drn);
		action = entdat(OLDDAT,drn);
		save_key = key;
		if (action == SAVE)
			drn = update(drn);
		if (action == DELT)
			delete(drn);
		if (action != DELT && FRELOK(file_no,R_LOCK,ldrn))
			loktyp(2);
		if (action == SAVE || action == DELT)
			{ key = save_key;
			  action = old_action;
			}
		old_action = action;
		conv_target.len = strlen(strncpy(conv_target.str, \
			idx_key.str,ky[key].key_len));
		idx_key.len = strlen(strcpy(idx_key.str,SET_LENGTH));
		lock_code = 0;

		stayput = YES;
		while (stayput);
		    { if (action == CONT)
			{ drn = AFTKEY(ky[key].key_num,file_no, \
				S_LOCK,&conv_target,&idx_key);
			  lock_code = LOKCOD();
			}
		      if (action == BACK)
			{ drn = BEFKEY(ky[key].key_num,file_no, \
				S_LOCK,&conv_target,&idx_key);
			  lock_code = LOKCOD();
			}

		      if (lock_code)
			stayput = check_lock(key,drn);
		      else
			stayput = NO;
		    }

		if (action == STOP)
			contnu = NO;
		}

	printf("\n\nSCAN ENDED");
	pause();
	return;

/*
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   			LIST CUSTOMERS
  
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

case 3:
	key = search_key();
	printf("\n\nDo you want listing routed to printer (Y/N) >>");
	scanf("%c",&route);
	if (route == 'y')
		route = 'Y';
	
	printf("\n\n\nEnter lower and upper limits for %s",ky[key].key_name);
	printf(" listing,\n     separate values with a space >>");
	scanf("%11s %11s",l_value.str,u_value.str);
	key_format(key,&l_value,&l_value);
	key_format(key,&u_value,&u_value);
	drn = SERKEY(ky[key].key_num,file_no,S_LOCK,&l_value,&idx_key);
	if (LOKCOD())
		skip_lock(key,drn);

	no_listed = 0;
	while (drn && keycmp(key,&idx_key,&u_value) <= 0)
		{
		read_cust(drn);
		print_cust(route);
		no_listed++;
		if (FRELOK(file_no,S_LOCK,drn))
			loktyp(4);
		l_value.len = strlen(strncpy(l_value.str,idx_key.str, \
			ky[key].key_len));
		idx_key.len = strlen(strcpy(idx_key.str,SET_LENGTH));
		drn = AFTKEY(ky[key].key_num,file_no,S_LOCK,&l_value,&idx_key);
		if (LOKCOD())
			skip_lock(key,drn);
		}

	if (drn)
		lock_code = FRELOK(file_no,S_LOCK,drn);
	else
		lock_code = 0;
	if (lock_code)
		loktyp(5);

	printf("\n\n%d records listed.",no_listed);
	pause();
	return;

/*
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		DATABASE STATISTICS
  
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

case 4:
	clrscr();
	printf("\n%s has %d records; currently, %d of them are in use.", \
		filname.str,GETDFS(file_no),GETDFU(file_no));
	printf("\n\n\n\nINDEX\t\t\t\tENTRIES");
	printf("\n-----------------\t\t-------");
	for (key = 0; key <= MAX_KEY; key++)
		printf("\n%s\t\t\t%d",ky[key].key_name,NOKEYS(key));

	printf("\n\n\n\n");
	pause();
	return;

/*
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		SAVE DATABASE UPDATES && RESTART
  
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

case 5:
	if (SAVDAT(file_no))
		error_type(0,7);
	for (key = 0; key <= MAX_KEY; key++)
		if (SAVIDX(ky[key].key_num))
			error_type(key,3);
	return;

/*
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		SAVE DATABASE UPDATES && TERMINATE
  
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

case 6:
	if (CLSDAT(file_no))
		error_type(0,15);
	for (key = 0; key <= MAX_KEY; key++)
		if (CLSIDX(ky[key].key_num))
			error_type(key,16);

	if (FRELOK(file_no,S_FILE,0))
		error_type(0,13);

	printf("\n\n ***  SUCCESSFUL TERMINATION ***");
	fclose(syslst);
	fclose(syscon);
	exit(1);
	}
    }



/*
   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  
  		BEGINNING OF UTILITY FUNCTIONS
  
  
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		CLEAR SCREEN ROUTINE
  
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

VOID clrscr()
	{
	WORD i;

	for (i = 0; i < 24; i++)
		printf("\n");
	}

/*
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		MAIN MENU ROUTINE
  
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

main_menu()
	{
	WORD op;

	printf("\n\t\t\t  AM-86(tm)  DEMONSTRATION");
	printf("\n\n\t\t\tCustomer Database Operations");
	printf("\n\t\t\t        Terminal %d",terminal);
	printf("\n\t\t\t****************************");
	printf("\n\n\n\t1. Enter New Customers");
	printf("\n\t2. Scan/Update/Delete Customer Records");
	printf("\n\t3. List Customer Records");
	printf("\n\t4. Database Statistics");
	printf("\n\t5. Save All Files & Restart Operations");
	printf("\n\t6. Terminate Operations");

	op = 0;
	while (op < 1 || op > 6)
		{ printf("\n\nEnter desired operation number>>");
		  scanf("%d",&op);
		}
	return(op);
	}

/*
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		SELECT SEARCH KEY ROUTINE
  
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

search_key()
	{
	WORD key,key_no;

	clrscr();
	printf("\n\t\t\tCustomer Database Search Keys\n\n\n");

	for (key = 0; key <= MAX_KEY; key++)
		printf("\n\t%d - %s",key+1,ky[key].key_name);

	key = 0;
	while (key < 1 || key > no_keys)
		{ printf("\n\n\nEnter desired key number>>");
		  scanf("%d",&key);
		}
	return(key-1);
	}

/*
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		ERROR HANDLING
  
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

VOID error_type(info,type)

WORD info,type;

    {
    WORD t_key;

    printf("\n\n\nUser Error #%d occurred while trying to ",ERRCOD());
    switch(type)
	{
		
case 1:	printf("open %s",idx_name[info].str);
	break;
case 2:	printf("search %s Index File",ky[info].key_name);
	goto ET_CLOSE; 
case 3:	printf("save %s",idx_name[info].str);
	goto ET_PCLOSE; 
case 4:	printf("remove old key from %s",idx_name[info].str);
	goto ET_CLOSE;
case 5:	printf("enter key into %s",idx_name[info].str);
	goto ET_CLOSE;
case 6:	printf("delete key from %s",idx_name[info].str);
	goto ET_CLOSE;
case 7:	printf("save %s",filname.str);
	info = -1;
	goto ET_PCLOSE;
case 8:	printf("get a new data record (%d)",file_no);
	break;
case 9:	printf("delete data record #%d",info);
	break;
case 10: printf("open %s (%d)",filname.str,file_no);
	 break;
case 11: printf("read data record #%d",info);
	 break;
case 12: printf("write data record #%d",info);
	 break;
case 13: printf("release shared file lock on %s",filname.str);
	 break;
case 14: printf("initialize user.");
	 exit(1);
case 15: printf("close %s",filname.str);
	 info = -1;
	 goto ET_PCLOSE;
case 16: printf("close %s",idx_name[info].str);
	 goto ET_PCLOSE;
	}

    err_term();

ET_CLOSE:
    CLSDAT(file_no);
    for (t_key = 0; t_key <= MAX_KEY; t_key++)
	if (t_key != info)
		CLSIDX(ky[t_key].key_num);
    err_term();

ET_PCLOSE:
    for (t_key = info + 1; t_key <= MAX_KEY; t_key++);
	CLSIDX(ky[t_key].key_num);
    }

VOID err_term()
	{
	printf("\n\nDEMONSTRATION TERMINATING WITH ERROR CODE #%d",ERRCOD());
	exit(1);
	}

VOID loktyp(type)

WORD type;

	{
	WORD t_key;

	printf("\nLock Type: %d   Lock Code: %d",type,LOKCOD());
	CLSDAT(file_no);
	for (t_key = 0; t_key <= MAX_KEY; t_key++)
		CLSIDX(ky[t_key].key_num);
	exit(1);
	}

/*
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
  		STRIP TRAILING BLANKS
  
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

strblk(RECFLD,fld_no)

BYTE *RECFLD;
WORD fld_no;

	{
	WORD endblk,fldlen;
	BYTE *fldptr;

	endblk = YES;
	fldlen = db[fld_no].fld_len;
	RECFLD = RECFLD + fldlen - 1; /* point to last byte */
	fldptr = db[fld_no].old_fld + fldlen; /* point to terminating byte */
	*fldptr-- = '\0';

	for (; fldlen > 0; fldlen--,RECFLD--,fldptr--)
		if (endblk)
			if (*RECFLD == ' ')
				*fldptr = '\0';
			else
				{ endblk = NO;
				  *fldptr = *RECFLD;
				}
		else
			*fldptr = *RECFLD;
	}

cpyfld(RECFLD,fld_no)	/* assumes null terminated field values */

BYTE *RECFLD;
WORD fld_no;

	{
	WORD fldlen,addblk;
	BYTE *fldptr;

	addblk = NO;
	for (fldlen = db[fld_no].fld_len,fldptr = db[fld_no].new_fld; \
	    fldlen > 0; fldlen--,fldptr++)
		if (!addblk && *fldptr != '\0')
			*RECFLD++ = *fldptr;
		else
			{ addblk = YES;
			  *RECFLD++ = ' ';
			}
	}

/*
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		READ DATA RECORD ROUTINE
  
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

VOID read_cust(drn)

WORD drn;

	{

	if (READAT(file_no,drn,&datbuf))
		error_type(drn,11);

	strblk(datbuf.CNO,0);
	strblk(datbuf.CFN,1);
	strblk(datbuf.CLN,2);
	strblk(datbuf.CST,3);
	strblk(datbuf.CTY,4);
	strblk(datbuf.CSA,5);
	strblk(datbuf.CZP,6);
	strblk(datbuf.CSU,7);
	}

/*
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		LIST CUSTOMER RECORD ROUTINE
  
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

VOID print_cust(route)

BYTE route;

	{
	FILE *list_file;

	if (route == 'Y')
		list_file = syslst;
	else
		list_file = syscon;

	fprintf(list_file,"\n\n\t%s\t%s",db[0].old_fld,db[7].old_fld);
	fprintf(list_file,"\n\t\t\t%s %s",db[1].old_fld,db[2].old_fld);
	fprintf(list_file,"\n\t\t\t%s",db[3].old_fld);
	fprintf(list_file,"\n\t\t\t%s, %s     %s\n",db[4].old_fld, \
		db[5].old_fld,db[6].old_fld);
	}

/*
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		PAUSE ROUTINE
  
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

VOID pause()
	{
	BYTE dummy;

	printf("\n\nEnter any character to continue ---");
	scanf("%c",&dummy);
	}

/*
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   	CONVERT TARGET VALUE TO KEY FORMAT ROUTINE
  
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

VOID key_format(key,t,ct)

WORD key;
BYTE *t,*ct;

	{
	BYTE temp[40],kl;

	if (uniq_key == key)
		strcpy(ct,t);	/* assumes alpha-numerics (no zero bytes
				   except for length byte).
				 */
	else
		{ t++;
		  ct++;		/* pointers now point to string (not
				   length byte of am86strg).
				 */
		  strcpy(temp,t);
		  strcat(temp,SPACE);
		  kl = ky[key].key_len - 2;
		  strncpy(ct,temp,kl);	/* pad key with blanks */
		  *(--ct) = kl + 2;	/* set length */
		  ct = ct + kl;		/* point to last two bytes */
		  *ct = '\0';
		  *++ct = '\0';		/* set last two bytes to nulls */
		}
	}

/*
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		COMPARE IDX_KEY & U_VALUE ROUTINE
  
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

keycmp(key,i,u)

WORD key;
BYTE *i,*u;

	{
	WORD kl;
	BYTE c1[40],c2[40];

	if (key == uniq_key)
		kl = ky[key].key_len;
	else
		kl = ky[key].key_len - 2;

	i++;
	u++;	/* point to actual string (not length byte) */

	strcpy(c1,i);
	strncat(c1,SPACE,kl);
	strcpy(c2,u);
	strncat(c2,SPACE,kl);
	
	if ((kl = strcmp(c1,c2)) < 0)
		return(-1);
	else if (kl)
		return(1);
	else
		return(0);
	}

/*
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
  		CHECK LOCK ROUTINES
  
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

VOID skip_lock(key,drn)

WORD key,drn;

	{
	struct am86strg l_value;

	while (drn && LOKCOD())
		{
		l_value.len = strlen(strncpy(l_value.str,idx_key.str, \
			ky[key].key_len));
		idx_key.len = strlen(strcpy(idx_key.str,SET_LENGTH));
		drn = AFTKEY(ky[key].key_num,file_no,S_LOCK,&l_value,&idx_key);
		}
	}

check_lock(key,drn)

WORD key,drn;

	{
	struct am86strg conv_target;
	BYTE dummy;

	printf("\n\nEnter a W if you wish to wait for locked record(s)>>");
	scanf("%c",&dummy);

	if (dummy == 'W' || dummy == 'w')
		return(YES);

	while (drn && LOKCOD())
		{
		conv_target.len = strlen(strncpy(conv_target.str,idx_key.str, \
			ky[key].key_len));
		idx_key.len = strlen(strcpy(idx_key.str,SET_LENGTH));
		if (old_action == CONT)
			drn = AFTKEY(ky[key].key_num,file_no, \
				S_LOCK,&conv_target,&idx_key);
		else
			drn = BEFKEY(ky[key].key_num,file_no, \
				S_LOCK,&conv_target,&idx_key);
		}
	return(NO);
	}

/*
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
  		WARNING MESSAGES
  
   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

VOID warning_type(key,type,ret_code)

WORD key,type,ret_code;

    {
    printf("\n\nWARNING...Return Code #%D occurred while trying to ", \
	ret_code);
    switch(type)
	{
case 1: printf("remove old key from %s",idx_name[key].str);
	pause();
	return;

case 2:	printf("enter key into %s",idx_name[key].str);
	pause();
	return;

case 3:	printf("delete key from %s",idx_name[key].str);
	pause();
	return;
	}
    }

/*
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		ADD NEW KEY VALUE ROUTINE
  
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

VOID add_key(key,drn)

WORD key,drn;

	{
	WORD ret_code,k_fld;
	struct am86strg tmpkey;

	k_fld = ky[key].key_map;

/*
	REMOVE OLD KEY VALUE
 */

	tmpkey.len = strlen(strcpy(tmpkey.str,db[k_fld].old_fld));
	ret_code = DELKEY(ky[key].key_num,file_no,X_LOCK,&tmpkey,drn);

	if (ERRCOD())
		error_type(key,4);
	if (LOKCOD())
		loktyp(6);
	if (ret_code != 1)
		warning_type(key,1,ret_code);

/*
	ADD NEW KEY VALUE
*/

	tmpkey.len = strlen(strcpy(tmpkey.str,db[k_fld].new_fld));
	ret_code = ADDKEY(ky[key].key_num,file_no,X_LOCK,&tmpkey,drn);

	if (ERRCOD())
		error_type(key,5);
	if (LOKCOD())
		loktyp(7);
	if (ret_code != 1)
		warning_type(key,2,ret_code);

	}


/*
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		WRITE NEW DATA RECORD ROUTINE
  
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

VOID write_cust(drn)

WORD drn;

	{
	datbuf.CDF[0] = '\0';			/* CLEAR DELETE FLAG */
	cpyfld(datbuf.CNO,0);
	cpyfld(datbuf.CFN,1);
	cpyfld(datbuf.CLN,2);
	cpyfld(datbuf.CST,3);
	cpyfld(datbuf.CTY,4);
	cpyfld(datbuf.CSA,5);
	cpyfld(datbuf.CZP,6);
	cpyfld(datbuf.CSU,7);

	if (WRTDAT(file_no,drn,&datbuf))
		error_type(drn,12);
	}
 
/*
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		DELETE KEY VALUE FROM INDEX ROUTINE
  
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

VOID del_key(key,drn)

WORD key,drn;

	{
	WORD ret_code;
	struct am86strg tmp_key;

	tmp_key.len = strlen(strcpy(tmp_key.str,db[ky[key].key_map].old_fld));
	
	ret_code = DELKEY(ky[key].key_num,file_no,X_LOCK,&tmp_key,drn);

	if (ERRCOD())
		error_type(key,6);
	if (LOKCOD())
		loktyp(10);
	if (ret_code != 1)
		warning_type(key,3,ret_code);
	}

/*
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		UPDATE INDICES && DATA FILE ROUTINE
  
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

update(drn)

WORD drn;

	{
	WORD key,fld,tmp_rec;

	if (!drn)
		{
		tmp_rec = NEWREC(file_no,X_LOCK);
		if (ERRCOD())
			error_type(0,8);
		if (LOKCOD())
			loktyp(3) ;
		}
	else
		tmp_rec = drn;

	for (key = 0; key <= MAX_KEY; key++)
		{ fld = ky[key].key_map;
		  if (strcmp(db[fld].old_fld,db[fld].new_fld))
			add_key(key,tmp_rec);
		}

	for (fld = 0; fld <= MAX_FIELD; fld++)
		if (strcmp(db[fld].old_fld,db[fld].new_fld))
			{ write_cust(tmp_rec);
			  return(tmp_rec);
			}
	return(tmp_rec);
	}

/*
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
   		DELETE INDEX && DATA FILE ENTRY ROUTINE
  
   :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 */

delete(drn)

WORD drn;

	{
	WORD key;

	for (key = 0; key <= MAX_KEY; key++)
		if (db[ky[key].key_map].old_fld[1] != '\0')
			del_key(key,drn);
	
	if (RETREC(file_no,X_LOCK,drn))
		error_type(drn,9);
	if (LOKCOD())
		loktyp(9);
	}

/*
		END OF UTILITY FUNCTIONS
 
   ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 */
