/* :::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	RECREATE PROGRAM  VERSION 1.02  06/13/83
	   REQUIRES AM86BUF = 4844 (decimal) BYTES

   ::::::::::::::::::::::::::::::::::::::::::::::::::::::::: */


#include <stdio.h>
#define MAX_KEY_LEN 48
#include <AM86DRC.H>
#include <RECREATE.H>

main () {

WORD dfile;

ret_chr = '\015';
printf("\nEnter recreate parameter file name:");
scanf("%14s",rec_par);
strcpy(rec_mode,"r");
if (!(rec_file = fopen(rec_par,rec_mode)))
	{ printf("\nCould not open %s\n",rec_par);
	  exit(1);
	}

if (fscanf(rec_file,"%d %d",&no_data_files,&node_sectors) < 0)
	{ printf("\nCould not read parameter file header.");
	  exit(1);
	}

terminal = -1;
erropt = YES;
timout = 2;
terminal = INTUSR(terminal,erropt,timout);

    /* only one key file and one data file are open at the same time. */

no_buffers = \
	(buf_space = BUFFER_SIZE - 70 - 198) / (node_sectors * 128 + 60);
if (no_buffers > 254)
	no_buffers = 254;

if (SETUP(no_buffers,1,node_sectors,1))
	{ printf("\nIllegal SETUP parameters.");
	  exit(1);
	}

for (dfile = 0; dfile < no_data_files; dfile++)
	{ rebuild();
	  printf("\n");
	}
printf("\nNormal Termination");
exit(1);
}

VOID abandon()
	{
	printf("\nRebuild Aborted!");
	fclose(rec_file);
	exit(1);
	}

VOID rebuild()
	{

	WORD no_keys,redo_data;

	if (fscanf(rec_file,"%s %d %d %d",filnam.str,&rec_len,&no_keys, \
	    &beg_rec.lwrd) < 0)
		{ printf("\nCould not read data file record (%s)",filnam.str);
		  abandon();
		}
	filnam.len = strlen(filnam.str);

	if (no_keys > MAX_KEYS)
		{ printf("\nToo many key files requested for data file %s.", \
			filnam.str);
		abandon();
		}

	if (rec_len > MAX_REC_LEN)
		{ printf("\nRecord length too great for data file %s.", \
			filnam.str);
		abandon();
		}

	if (no_keys)
	    for (key = 0; key < no_keys; key++)
		{ if (fscanf(rec_file,"%s %d %d %d %d %c",idxnam[key].str, \
		    &key_len[key][0],&key_type[key],&auto_suffix[key], \
		    &no_key_parts[key],&blk_to_nul[key]) < 0)
			{ printf("\nCould not read key file record (%s)", \
			    idxnam[key].str);
			  abandon();
			}
		  idxnam[key].len = strlen(idxnam[key].str);

		  if (blk_to_nul[key] == 'y')
			blk_to_nul[key] = 'Y';

		  if (no_key_parts[key] < 1 || no_key_parts[key] > \
		    MAX_PARTS)
			{ printf("\nIllegal # of key parts (%d) for %s.", \
			    no_key_parts[key],idxnam[key].str);
			  abandon();
			}
		  for (part = 1; part <= no_key_parts[key]; part++)
			if (fscanf(rec_file,"%d %d",&key_pos[key][part], \
			    &key_len[key][part]) < 0)
				printf( \
"\nCould not read key part record for %s (part #%d).",idxnam[key].str,part);
		}

	redo_data = rbld_data();

	if (redo_data == 2)
		printf("\nData file %s could not be locked.",filnam.str);

	if (redo_data == 3)
		printf("\nData file %s is apparently empty.",filnam.str);

	if (redo_data < 0)
	    printf("\nUnanticipated AM86 Error #%d while processing %s", \
		-redo_data,filnam.str);

	if (redo_data < 0 || redo_data > 1)
		{ printf("\nNo rebuild performed.");
		  return;
		}

	rbld_indx(redo_data,no_keys);

	printf("\nRebuild for %s completed.",filnam.str);

	}

rbld_data()
	{

	WORD temp,status;

	status = 0;
	file_no = OPNDAT(-1,X_FILE,&filnam,rec_len);

	if (ERRCOD() == END_DATA_FILE)
		{ CLSDAT(file_no);
		  return(3);
		}

	if (ERRCOD() == CRPT_DATA)
		{ status = 1;
		  file_no = OPRDAT(file_no,X_FILE,&filnam,rec_len);
		}

	if (!status && ERRCOD())
		{ temp = ERRCOD();
		  CLSDAT(file_no);
		  return(-temp);
		}

	if (LOKCOD())
		{ CLSDAT(file_no);
		  return(2);
		}

	if (beg_rec.lwrd == 0L)
		beg_rec.lwrd = (128 + rec_len - 1) / rec_len + 1;

	if (!status)
		{ CLSDAT(file_no);
		  printf("\nNo need to modify %s.",filnam.str);
		  return(0);
		}

/*
	DATA FILE IS CORRUPTED. MUST BE REBUILT.
 */

	printf("\nRebuilding data file %s",filnam.str);

	drn.lwrd = beg_rec.lwrd;
	del_ptr.lwrd = 0L;
	no_del.lwrd = beg_rec.lwrd - 1L; /* allowance for header record(s) */

	SETDAT(drn.s.h);
	while (READAT(file_no,drn.s.l,inpbuf) != END_DATA_FILE)
		{
		if (ERRCOD())
			{ temp = ERRCOD();
		  	  CLSDAT(file_no);
		  	  return(-temp);
			}

		printf("\n%s %d",filnam.str,drn.lwrd);

		if (inpbuf[0] == DEL_FLG)
			{ wrt_del_lnk();
			  no_del.lwrd++;
			}

		drn.lwrd++;
		SETDAT(drn.s.h);
		}


	printf("\n%s is reorganized. Now rebuild index files.",filnam.str);

	if (CLSDAT(file_no))
		{ printf( \
		    "\nCould not close data file %s (to recreate header)", \
		    filnam.str);
		  abandon();
		}

	rec_hdr();
	return(1);
	}
