#include <stdio.h>
#define MAX_KEY_LEN 48
#include <AM86DRC.H>
#include <RECREATE.H>

VOID wrt_del_lnk()
	{
	LONG lseek();
	lnkbuf.del_lnk = DEL_FLG;
	lnkbuf.del_top = del_ptr.lwrd;

	SETDAT(drn.s.h);
	if (WRTDAT(file_no,drn.s.l,&lnkbuf))
		{ printf( \
"\nCould not rewrite deleted record.\nData file %s (%d)",filnam.str,drn.lwrd);
		  abandon();
		}

	del_ptr.lwrd = drn.lwrd;
	}

VOID rec_hdr()
	{
	WORD temp,hdr_file;

	if ((hdr_file = openb(filnam.str,2)) < 0 )
		{ printf("\nCould not re-open %s to write header.", \
			filnam.str);
		  abandon();
		}

	hdrbuf.siz_fld = --drn.lwrd;			/* DRN = file size */
	hdrbuf.utl_fld = drn.lwrd - no_del.lwrd;
	hdrbuf.del_fld = del_ptr.lwrd;
	hdrbuf.cor_flg = 0;

	if (lseek(hdr_file,0L,0) == -1L || write(hdr_file,&hdrbuf,13) != 13)
		{ printf("\nCould not write header in %s.",filnam.str);
		  close(hdr_file);
		  abandon();
		}

	close(hdr_file);
	}
	

VOID rbld_indx(redo_data,no_keys)

WORD redo_data,no_keys;

	{
	WORD key_no,key,temp;

	if (no_keys < 1) return;

	file_no = OPNDAT(-1,X_FILE,&filnam,rec_len);
	if (ERRCOD() || LOKCOD())
		{ printf( \
"\nCould not attempt index rebuild.\nError/Lock Codes...%d/%d", \
			ERRCOD(),LOKCOD());
		  CLSDAT(file_no);
		  return;
		}

	for (key = 0; key < no_keys; key++)
		{
		key_no = OPNIDX(-1,&idxnam[key],key_len[key][0],
			key_type[key],auto_suffix[key]);

		if (!ERRCOD() && !redo_data && (NOKEYS(key_no) || DATVAL()))
			{ printf("\n%s is OK as is. No rebuild performed.", \
				idxnam[key].str);
			  continue;
			}

		if (ERRCOD() && ERRCOD() != CRPT_INDEX && ERRCOD() != \
		    END_INDEX_FILE)
			{ printf("\nUnanticipated Error with ");
			  key_error(key,key_no);
			  continue;
			}

		if (ERRCOD() == CRPT_INDEX)
			key_no = OPRIDX(key_no,&idxnam[key],key_len[key][0], \
				key_type[key],auto_suffix[key]);

		if (ERAIDX(key_no))
			{ printf("\nCould not erase old ");
			  key_error(key,key_no);
			  continue;
			}

		key_no = OPNIDX(-1,&idxnam[key],key_len[key][0], \
			key_type[key],auto_suffix[key]);
		if (ERRCOD())
			{ printf("\nCould not re-open ");
			  key_error(key,key_no);
			  continue;
			}

		no_sort = sort_setup(key);
		sort_read(key,key_no);
		if (CLSIDX(key_no))
			{ printf("\nCould not close ");
			  key_error(key,key_no);
			}
		}

	CLSDAT(file_no);
	}

VOID key_error(key,key_no)

WORD key,key_no;

	{
	printf(" %s Error #%d\nIndex not rebuilt.",idxnam[key].str,ERRCOD());
	}

sort_setup(key)

WORD key;

	{
	return(min(MAX_SORT, \
		(MAX_SPACE - MAX_KEY_LEN) / (key_len[key][0] + 1)));
	}

put_keyval(i,key)

WORD i,key;

	{
	BYTE *key_siz,*key_val,*key_prt,chkblk();
	WORD tmp_len,j,tmp_i;

	key_siz = keyval + (i - 1) * (key_len[key][0] + 1);
	key_val = key_siz + 1;
	for (tmp_i = 1,tmp_len = 0; tmp_i <= no_key_parts[key]; tmp_i++)
		{ key_prt = inpbuf + key_pos[key][tmp_i] - 1;
		  for (j = 0; j < key_len[key][tmp_i]; j++)
			*key_val++ = *key_prt++;
		  tmp_len = tmp_len + key_len[key][tmp_i];
		}
	*key_siz = chkblk(key_siz,tmp_len);
	}

struct am86strg *get_keyval(i,key)

WORD i,key;

	{
	return(keyval + (i - 1) * (key_len[key][0] + 1));
	}

entry_error(key_no,lrec)

WORD key_no;
LONG lrec;

	{
	printf("\nError #%d (rec #%d) during index rebuild.", \
		ERRCOD(),lrec);
	CLSDAT(file_no);
	ERAIDX(key_no);
	abandon();
	}

sort_read(key,key_no)

WORD key,key_no;

	{
	WORD end_file,temp;

	drn.lwrd = beg_rec.lwrd;
	end_file = NO;

	printf("\n                        %c",ret_chr);

	while (!end_file)
	    {
	    no_read = 0;
	    while (no_read < no_sort)
		{
		SETDAT(drn.s.h);
		temp = READAT(file_no,drn.s.l,inpbuf);

		if (temp == END_DATA_FILE || temp == INVALID_RECORD)
			{ end_file = YES;
			  break;
			}

		if (temp)
			{ printf("\nCould not read %s",filnam.str);
			  entry_error(key_no,drn.lwrd);
			}

		if (inpbuf[0] != DEL_FLG)
			{ printf("%s %d %c",filnam.str,drn.lwrd,ret_chr);
			  put_keyval(++no_read,key);
			  sort_drn[no_read].s.l = drn.s.l;
			  sort_drn[no_read].s.h = drn.s.h;
			}

		drn.lwrd++;
		}

	    printf("                        %c",ret_chr);
	    sort_index(key,key_no,no_read);
	    }

	printf("\n%s is rebuilt.",idxnam[key].str);
	}

sort_index(key,key_no,no_read)

WORD key,key_no,no_read;

	{
	struct am86strg *key_val,*get_keyval();
	WORD i,ret_code;

	if (!no_read) return;

	sort_keyval(key,no_read);

	i = link[0];
	while (i)
		{
		key_val = get_keyval(i,key);
		SETDAT(sort_drn[i].s.h);
		ret_code = ADDKEY(key_no,file_no,N_LOCK,key_val, \
			sort_drn[i].s.l);
		if (ERRCOD())
			{ printf("\nCould not enter key value in %s", \
				idxnam[key].str);
			  entry_error(key_no,sort_drn[i].lwrd);
			}

		if (ret_code != 1)
			{ printf( \
"\nWARNING...ADDKEY Return Code: %d\nwhile processing rec #%d for %s\n", \
				ret_code,sort_drn[i].lwrd,idxnam[key].str);
			}
		else
			printf("%s %d %c",idxnam[key].str,sort_drn[i].lwrd, \
				ret_chr);

		i = link[i];
		}
	}

sort_keyval(key,no_read)

WORD key,no_read;

	{
	struct am86strg *key_val,*get_keyval();
	WORD j,p,q;

	link[0] = no_read;
	link[no_read] = 0;

	if (no_read < 2) return;

	for (j = no_read; j > 0; j--)
		{
		p = link[0];
		q = 0;
		key_val = get_keyval(j,key);
L3:
		if (keycmp(key,key_val,get_keyval(p,key)) < 0)
			goto L5;
L4:
		q = p;
		p = link[q];
		if (p > 0)
			goto L3;
L5:
		link[q] = j;
		link[j] = p;
		}
	}

keycmp(key,k,g)

WORD key;
BYTE *k,*g;

	{
	WORD keylen;

	keylen = key_len[key][0];
	if (auto_suffix[key])
		keylen = keylen - 2;

	k++;
	g++;
	while (keylen-- > 0 && *(k++) == *(g++))
		;
	return(*(--k) - *(--g));
	}

BYTE chkblk(k,t)

BYTE *k;
WORD t;

	{
	WORD save_t;

	save_t = t;
	while (t-- > 0 && *++k == ' ')
		;
	if (!t && *k == ' ')
		return(0);
	else
		return(save_t);
	}
